'
'  ras_wrap.bas
'
'  Ras Services wrapper functions.
'
'
#if not %def(%PB_RAS_BAS)

%PB_RAS_BAS = 1


'- Set to 0 if you wish to call the functions
'  and have the dll loaded automatically by
'  your application. Set to non-zero
'  to dynamically load the dll as needed.
'  Setting it to 1 allows for the circumstance
'  of the DLL not existing on someone's computer.
'
%RAS_DYNAMIC_LOAD = 1

%RASBASE = 600

%ERROR_INVALID_PORT_HANDLE             = %RASBASE + 1
%ERROR_BUFFER_TOO_SMALL                = %RASBASE + 3
%ERROR_BUFFER_INVALID                  = %RASBASE + 10
%ERROR_CANNOT_FIND_PHONEBOOK_ENTRY     = %RASBASE + 23
%ERROR_INVALID_SIZE                    = %RASBASE + 32

%RAS_MAXENTRYNAMEBUFFER = 257
%RAS_MAXDEVICETYPE      = 16
%RAS_MAXENTRYNAME       = 256
%RAS_MAXDEVICENAME      = 128
%RAS_MAXPHONENUMBER     = 128
%RAS_MAXCALLBACKNUMBER  = %RAS_MAXPHONENUMBER
%ULEN                   = 256
%PWLEN                  = 256
%DNLEN                  = 15

'- Connection Status Constants
%RASCS_PAUSED                 = &h1000
%RASCS_DONE                   = &h2000
%RASCS_Connected              = %RASCS_DONE

'- The members are not dword aligned, but the whole
'  structure has to fit into a 4-byte bounded memory space,
'  thus the extra 3-byte buffer at the end of the structure.
'  So far, all of the ras structures I've found work this
'  way. NOTE: This is not the same as using the Dword specifier
'  in the type declaration (that would dword align each
'  member of the structure).
'
Type RASENTRYNAME
   dwSize As Dword
   szEntryName As Asciiz * %RAS_MAXENTRYNAMEBUFFER
   buffer As Asciiz * 3
End Type

Type RASDIALPARAMS
   dwSize As Dword                                             '4
   szEntryName As Asciiz * %RAS_MAXENTRYNAME + 1               '257
   szPhoneNumber As Asciiz * %RAS_MAXPHONENUMBER + 1           '129
   szCallBackNumber As Asciiz * %RAS_MAXCALLBACKNUMBER + 1     '129
   szUserName As Asciiz * %ULEN + 1                            '257
   szPassword As Asciiz * %PWLEN + 1                           '257
   szDomain As Asciiz * %DNLEN + 1                             '16
   buffer As String * 3                                        '3
End Type

Type RASDIALEXTENSIONS
   dwSize As Dword
   dwfOptions As Dword
   hwndParent As Long
   reserved As Long
End Type

Type RASCONN
   dwSize As Dword                                       '4
   hRasConn As Long                                      '4          8
   szEntryName As Asciiz * %RAS_MAXENTRYNAME + 1         '257        265
   szDeviceType As Asciiz * %RAS_MAXDEVICETYPE + 1       '17         282
   szDeviceName As Asciiz * %RAS_MAXDEVICENAME + 1       '129        411
   buffer As String * 1                                  '1          412
End Type

Type RASCONNSTATUS
   dwSize As Dword                                      '4
   rasconnstate As Long                                 '4    8
   dwError As Dword                                     '4    12
   szDeviceType As Asciiz * %RAS_MAXDEVICETYPE + 1      '17   29
   szDeviceName As Asciiz * %RAS_MAXDEVICENAME + 1      '129  158
   buffer As String * 2                                 '1    160
End Type

Type RASDIALDLG_TYPE
   dwSize as Dword
   hwndOwner as Long
   dwFlags as Dword
   xDlg as Long
   yDlg as Long
   dwSubEntry as Dword
   dwError as Dword
   reserved1 as DWord
   reserved2 as DWord
End Type


#If %RAS_DYNAMIC_LOAD

Global gRasLibrary As Long

'- Call template
Declare Function callTemplate_RasGetConnectStatus _
      (  ByVal hRasConn As Long, lpRasConnStatus As RASCONNSTATUS ) As Long

Declare Function callTemplate_RasEnumEntries _
      (  zReserved As Asciiz, zPhoneBook As Asciiz, lpRasEntry As RASENTRYNAME, _
         lpCb As Long, lpcEntries As Long ) As Long

Declare Function callTemplate_RasGetEntryDialParams _
      (  zPhoneBook As Asciiz, rDialParams As RASDIALPARAMS, iPassword As Long ) As Long

Declare Function callTemplate_RasDial _
      (  lpRasDialExtensions As RASDIALEXTENSIONS, lpszPhoneBook As Asciiz, _
         lpRasDialParams As RASDIALPARAMS, ByVal dwNotiferType As Dword, _
         ByVal lpvNotifier As Long, lphRasConn As Long   ) As Dword

Declare Function callTemplate_RasHangUp _
      (  ByVal hRasConn As Long ) As Long

Declare Function callTemplate_RasEnumConnections _
      (  lpRasConn As RASCONN, lpcb As Long, lpcConnections As Long ) As Dword

Declare Function callTemplate_RasDialDlg _
      (  zPhonebook as Asciiz, zEntry as Asciiz, zPhoneNumber as Asciiz, _
         rInfo as RASDIALDLG_TYPE ) as Long



'=================================================================================================
Function RasInitDLL Alias "RasInitDLL" Export As Long

   If gRasLibrary = 0 Then
      gRasLibrary = LoadLibrary("rasapi32.dll")
   End If
   Function = gRasLibrary

End Function

'=================================================================================================
Sub RasUnloadDLL Alias "RasUnloadDLL" Export

   If gRasLibrary <> 0 Then
      FreeLibrary gRasLibrary
      gRasLibrary = 0
   End If

End Sub

'=================================================================================================
Function RasGetConnectStatus _
      (  ByVal hRasConn As Long, lpRasConnStatus As RASCONNSTATUS ) As Long

   Dim ptr_RasGetConnectStatus As Dword
   Dim iLoadedHere As Long
   Dim iReturn As Long

   iLoadedHere = %False
   If gRasLibrary = 0 Then
      RasInitDLL
      If gRasLibrary <> 0 Then
         iLoadedHere = %True
      End If
   End If

   If gRasLibrary = 0 Then
      Function = 0
      Exit Function
   End If

   ptr_RasGetConnectStatus = GetProcAddress(gRasLibrary, "RasGetConnectStatusA")
   If ptr_RasGetConnectStatus <> 0 Then
      Call Dword ptr_RasGetConnectStatus Using callTemplate_RasGetConnectStatus( hRasConn, lpRasConnStatus ) To iReturn
   Else
      iReturn = 0
   End If

   If iLoadedHere Then
      RasUnloadDLL
   End If

   Function = iReturn

End Function

'=================================================================================================
Function RasEnumEntries _
      (  zReserved As Asciiz, zPhoneBook As Asciiz, lpRasEntry As RASENTRYNAME, _
         lpCb As Long, lpcEntries As Long ) As Long

   Dim ptr_RasEnumEntries As Dword
   Dim iLoadedHere As Long
   Dim iReturn As Long

   iLoadedHere = %False
   If gRasLibrary = 0 Then
      RasInitDLL
      If gRasLibrary <> 0 Then
         iLoadedHere = %True
      End If
   End If

   If gRasLibrary = 0 Then
      Function = 0
      Exit Function
   End If

   ptr_RasEnumEntries = GetProcAddress(gRasLibrary, "RasEnumEntriesA")
   If ptr_RasEnumEntries <> 0 Then
      Call Dword ptr_RasEnumEntries Using callTemplate_RasEnumEntries( zReserved, zPhoneBook, lpRasEntry, lpCb, lpcEntries ) To iReturn
   Else
      iReturn = 0
   End If

   If iLoadedHere Then
      RasUnloadDLL
   End If

   Function = iReturn

End Function

'=================================================================================================
Function RasGetEntryDialParams _
      (  zPhoneBook As Asciiz, rDialParams As RASDIALPARAMS, iPassword As Long ) As Long

   Dim ptr_RasGetEntryDialParams As Dword
   Dim iLoadedHere As Long
   Dim iReturn As Long

   iLoadedHere = %False
   If gRasLibrary = 0 Then
      RasInitDLL
      If gRasLibrary <> 0 Then
         iLoadedHere = %True
      End If
   End If

   If gRasLibrary = 0 Then
      Function = 0
      Exit Function
   End If

   ptr_RasGetEntryDialParams = GetProcAddress(gRasLibrary, "RasGetEntryDialParamsA")
   If ptr_RasGetEntryDialParams <> 0 Then
      Call Dword ptr_RasGetEntryDialParams Using callTemplate_RasGetEntryDialParams( zPhoneBook, rDialParams, iPassword ) To iReturn
   Else
      iReturn = 0
   End If

   If iLoadedHere Then
      RasUnloadDLL
   End If

   Function = iReturn

End Function

'=================================================================================================
Function RasDial _
      (  lpRasDialExtensions As RASDIALEXTENSIONS, lpszPhoneBook As Asciiz, _
         lpRasDialParams As RASDIALPARAMS, ByVal dwNotiferType As Dword, _
         ByVal lpvNotifier As Long, lphRasConn As Long   ) As Dword


   Dim ptr_RasDial As Dword
   Dim iLoadedHere As Long
   Dim iReturn As Long

   iLoadedHere = %False
   If gRasLibrary = 0 Then
      RasInitDLL
      If gRasLibrary <> 0 Then
         iLoadedHere = %True
      End If
   End If

   If gRasLibrary = 0 Then
      Function = 0
      Exit Function
   End If

   ptr_RasDial = GetProcAddress(gRasLibrary, "RasDialA")
   If ptr_RasDial <> 0 Then
      Call Dword ptr_RasDial Using callTemplate_RasDial( lpRasDialExtensions, lpszPhoneBook, _
                                       lpRasDialParams, dwNotiferType, lpvNotifier, lphRasConn ) To iReturn
   Else
      iReturn = 0
   End If

   If iLoadedHere Then
      RasUnloadDLL
   End If

   Function = iReturn


End Function

'=================================================================================================
Function RasHangUp _
      (  ByVal hRasConn As Long ) As Long

   Dim ptr_RasHangUp As Dword
   Dim iLoadedHere As Long
   Dim iReturn As Long

   iLoadedHere = %False
   If gRasLibrary = 0 Then
      RasInitDLL
      If gRasLibrary <> 0 Then
         iLoadedHere = %True
      End If
   End If

   If gRasLibrary = 0 Then
      Function = 0
      Exit Function
   End If

   ptr_RasHangUp = GetProcAddress(gRasLibrary, "RasHangUpA")
   If ptr_RasHangUp <> 0 Then
      Call Dword ptr_RasHangUp Using callTemplate_RasHangUp( hRasConn ) To iReturn
   Else
      iReturn = 0
   End If

   If iLoadedHere Then
      RasUnloadDLL
   End If

   Function = iReturn

End Function

'=================================================================================================
Function RasEnumConnections _
      (  lpRasConn As RASCONN, lpcb As Long, lpcConnections As Long ) As Dword

   Dim ptr_RasEnumConnections As Dword
   Dim iLoadedHere As Long
   Dim iReturn As Long

   iLoadedHere = %False
   If gRasLibrary = 0 Then
      RasInitDLL
      If gRasLibrary <> 0 Then
         iLoadedHere = %True
      End If
   End If

   If gRasLibrary = 0 Then
      Function = 0
      Exit Function
   End If

   ptr_RasEnumConnections = GetProcAddress(gRasLibrary, "RasEnumConnectionsA")
   If ptr_RasEnumConnections <> 0 Then
      Call Dword ptr_RasEnumConnections Using callTemplate_RasEnumConnections( lpRasConn, lpcb, lpcConnections ) To iReturn
   Else
      iReturn = 0
   End If

   If iLoadedHere Then
      RasUnloadDLL
   End If

   Function = iReturn

End Function

'=================================================================================================
Function RasDialDlg _
      (  zPhonebook as Asciiz, zEntry as Asciiz, zPhoneNumber as Asciiz, _
         rInfo as RASDIALDLG_TYPE ) as Long

   Dim ptr_RasDialDlg As Dword
   Dim iLoadedHere As Long
   Dim iReturn As Long

   iLoadedHere = %False
   If gRasLibrary = 0 Then
      RasInitDLL
      If gRasLibrary <> 0 Then
         iLoadedHere = %True
      End If
   End If

   If gRasLibrary = 0 Then
      Function = 0
      Exit Function
   End If

   ptr_RasDialDlg = GetProcAddress(gRasLibrary, "RasDialDlg")
   If ptr_RasDialDlg <> 0 Then
      Call Dword ptr_RasDialDlg Using callTemplate_RasDialDlg _
            ( zPhonebook, zEntry, zPhoneNumber, rInfo ) to iReturn
   Else
      iReturn = 0
   End If

   If iLoadedHere Then
      RasUnloadDLL
   End If

   Function = iReturn

End Function

#Else

'- Functions
'Declare Function RasGetConnectStatus Lib "rasapi32.dll" Alias "RasGetConnectStatusA" _
'      (  ByVal hRasConn As Long, lpRasConnStatus As RASCONNSTATUS ) As Long
'
'Declare Function RasEnumEntries Lib "rasapi32.dll" Alias "RasEnumEntriesA" _
'      (  zReserved As Asciiz, zPhoneBook As Asciiz, lpRasEntry As RASENTRYNAME, _
'         lpCb As Long, lpcEntries As Long ) As Long
'
'Declare Function RasGetEntryDialParams Lib "rasapi32.dll" Alias "RasGetEntryDialParamsA" _
'      (  zPhoneBook As Asciiz, rDialParams As RASDIALPARAMS, iPassword As Long ) As Long
'
'Declare Function RasDial Lib "rasapi32.dll" Alias "RasDialA" _
'      (  lpRasDialExtensions As RASDIALEXTENSIONS, lpszPhoneBook As Asciiz, _
'         lpRasDialParams As RASDIALPARAMS, ByVal dwNotiferType As Dword, _
'         ByVal lpvNotifier As Long, lphRasConn As Long   ) As Dword
'
'Declare Function RasHangUp Lib "rasapi32.dll" Alias "RasHangUpA" _
'      (  ByVal hRasConn As Long ) As Long
'
'Declare Function RasEnumConnections Lib "rasapi32.dll" Alias "RasEnumConnectionsA" _
'      (  lpRasConn As RASCONN, lpcb As Long, lpcConnections As Long ) As Dword

'Declare Function RasDialDlg Lib "rasapi32.dll" Alias "RasDialDlgA" _
'      (  zPhonebook as Asciiz, zEntry as Asciiz, zPhoneNumber as Asciiz, _
'         rInfo as RASDIALDLG_TYPE ) as Long
'
#EndIf     ' if %RAS_DYNAMIC_LOAD, else

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  load_ras_entries                                               NOT EXPORTED
'
'  Fills the given array with the entries in the ras phone book.
'  The array rEntry is 1-based.
'  Returns the number of entries in the array.
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function load_ras_entries(rEntry() As RASENTRYNAME) As Long

   Dim iRet As Long
   Dim iBufSize As Long
   Dim iNumEntries As Long

   ReDim rEntry(1 To 1) As RASENTRYNAME
   iBufSize = SizeOf(rEntry(1))
   rEntry(1).dwSize = SizeOf(rEntry(1))
   iRet = RasEnumEntries(ByVal 0, ByVal 0, rEntry(1), iBufSize, iNumEntries)

   '- If we have more than one entry, we'll need
   '  to increase the size of the array.
   '
   If iRet = %ERROR_BUFFER_TOO_SMALL Then
      ReDim rEntry(1 To iNumEntries) As RASENTRYNAME
      iBufSize = SizeOf(rEntry(1)) * iNumEntries
      rEntry(1).dwSize = SizeOf(rEntry(1))
      iRet = RasEnumEntries(ByVal 0, ByVal 0, rEntry(1), iBufSize, iNumEntries)
   End If

   If iRet <> 0 Then
      Function = 0
   Else
      Function = iNumEntries
   End If

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  hangup_and_wait                                                NOT EXPORTED
'
'  This routine hangs up a ras connection. Because it takes the program time
'  to disconnect, we need to wait until the ras handle is invalidated.
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub hangup_and_wait(ByVal hRas As Long)

   Dim iRet As Long
   Dim rStatus As RASCONNSTATUS

   RasHangUp hRas

   Do
      rStatus.dwSize = SizeOf(rStatus)
      iRet = RasGetConnectStatus(hRas, rStatus)
      apiSleep 5
   Loop Until iRet <> 0

End Sub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  collect_active                                                 NOT EXPORTED
'
'  Takes an array of structures to fill with information
'  about the active connections.
'  Returns the number of connections found and zero on error.
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function collect_active(rConn() As RASCONN) As Long

   Dim iBufSize As Long
   Dim iNumConn As Long
   Dim iRet As Long
   Dim rConn(1 To 100) As RASCONN      'assuming never more than 100
                                       'active connections (safe for now!)

   iBufSize = SizeOf(rConn(1)) * UBound(rConn)
   rConn(1).dwSize = SizeOf(rConn(1))
   iRet = RasEnumConnections(rConn(1), iBufSize, iNumConn)
   If iRet = 0 Then
      Function =iNumConn
   Else
      Function = %False
   End If

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsAvailableEntries
'
'  Returns a count of the available entries
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsAvailableEntries Alias "rsAvailableEntries" _
      Export As Long

   Dim rEntry(1) As RASENTRYNAME

   Function = load_ras_entries(rEntry())

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsGetEntryName
'
'  Returns a RAS entry by name based in it's number
'  as returned by rsAvailableEntries
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsGetEntryName Alias "rsGetEntryName" _
      ( ByVal iEntry As Long ) Export As String

   Dim iCount As Long
   Dim rEntry(1) As RASENTRYNAME

   iCount = load_ras_entries(rEntry())
   If (iEntry < 1) Or (iEntry > iCount) Then
      Function = ""
   Else
      Function =  Trim$(rEntry(iEntry).szEntryName)
   End If

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rszGetEntryName
'
'  Same as rsGetEntryName, but returns a pointer to a string instead of a
'  vb/pb string.
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rszGetEntryName Alias "rszGetEntryName" _
      ( ByVal iEntry As Long ) Export As Dword

   Dim sString As String

   sString = rsGetEntryName(iEntry) + Chr$(0)
   Function = StrPtr(sString)

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsDialEntry
'
'  Dials a RAS Connection
'     Returns  non-zero RAS Handle On success
'              %False On Failure
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsDialEntry Alias "rsDialEntry" _
      ( ByVal iEntry As Long ) Export As Long

   Dim hRas As Long
   Dim iRet As Long
   Dim iCount As Long
   Dim iPassword As Long
   Dim rEntry(1) As RASENTRYNAME
   Dim rDial As RASDIALPARAMS
   Dim rDialEx As RASDIALEXTENSIONS
   Dim rStatus As RASCONNSTATUS

   '- Find the entry we want
   iCount = load_ras_entries(rEntry())
   If (iCount < 1) Or (iEntry < 1) Or (iEntry > iCount) Then
      Function = %False
   Else

      '- Get it's dialing parameters
      rDial.dwSize = SizeOf(rDial)
      rDial.szEntryName = Trim$(rEntry(iEntry).szEntryName)
      iRet = RasGetEntryDialParams(ByVal 0, rDial, iPassword)
      If iRet <> 0 Then
         Function = %False
      Else

         '- Make the connection
         rDial.dwSize = SizeOf(rDial)
         rDialEx.dwSize = SizeOf(rDialEx)
         iRet = RasDial ( rDialEx, ByVal 0, rDial, 0, 0, hRas )

         '- Check for an error
         If iRet <> 0 Then
            hangup_and_wait hRas
            Function = %False
         Else

            '- Get the connections status
            rStatus.dwSize = SizeOf(rStatus)
            If RasGetConnectStatus(hRas, rStatus) <> 0 Then
               hangup_and_wait hRas
               Function = %False
            Else
               If rStatus.rasconnstate = %RASCS_CONNECTED Then
                  Function = hRas
               Else
                  hangup_and_wait hRas
                  Function = %False
               End If
            End If
         End If
      End If
   End If

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsDialEntryEx
'
'  Dials a RAS Connection
'     Returns  non-zero RAS Handle On success
'              %False On Failure
'  Just like rsDialEntry, except, it takes user id and password parameters
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsDialEntryEx Alias "rsDialEntryEx" _
      ( ByVal iEntry As Long, zUser As Asciiz, zPassword As Asciiz ) _
        Export As Long

   Dim hRas As Long
   Dim iRet As Long
   Dim iCount As Long
   Dim iPassword As Long
   Dim rEntry(1) As RASENTRYNAME
   Dim rDial As RASDIALPARAMS
   Dim rDialEx As RASDIALEXTENSIONS
   Dim rStatus As RASCONNSTATUS

   '- Find the entry we want
   iCount = load_ras_entries(rEntry())
   If (iCount < 1) Or (iEntry < 1) Or (iEntry > iCount) Then
      Function = %False
   Else

      '- Get it's dialing parameters
      rDial.dwSize = SizeOf(rDial)
      rDial.szEntryName = Trim$(rEntry(iEntry).szEntryName)
      iRet = RasGetEntryDialParams(ByVal 0, rDial, iPassword)
      If iRet <> 0 Then
         Function = %False
      Else

         '- Make the connection
         rDial.dwSize = SizeOf(rDial)
         rDial.szUserName = zUser
         rDial.szPassword = zPassword
         rDialEx.dwSize = SizeOf(rDialEx)

         iRet = RasDial ( rDialEx, ByVal 0, rDial, 0, 0, hRas )

         '- Check for an error
         If iRet <> 0 Then
            hangup_and_wait hRas
            Function = %False
         Else

            '- Get the connections status
            rStatus.dwSize = SizeOf(rStatus)
            If RasGetConnectStatus(hRas, rStatus) <> 0 Then
               hangup_and_wait hRas
               Function = %False
            Else
               If rStatus.rasconnstate = %RASCS_CONNECTED Then
                  Function = hRas
               Else
                  hangup_and_wait hRas
                  Function = %False
               End If
            End If
         End If
      End If
   End If

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsActiveConnections
'
'  Returns a count of active connections
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsActiveConnections Alias "rsActiveConnections" _
      Export As Long

   Dim rConn(1 To 100) As RASCONN

   Function = collect_active(rConn())

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsGetConnectionName
'
'  Returns the entry name of an active connection based on it's "number"
'  as returned by rsActiveConnections
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsGetConnectionName Alias "rsGetConnectionName" _
      ( ByVal iConnection As Long ) Export As String

   Dim iNumConn As Long
   Dim rConn(1 To 100) As RASCONN      'assuming never more than 100
                                       'active connections (safe for now!)

   iNumConn = collect_active(rConn())
   If (iConnection < 1) Or (iConnection > iNumConn) Then
      Function = ""
   Else
      Function = Trim$(rConn(1).szEntryName)
   End If

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rszGetConnectionName
'
'  Same as rsGetConnectionName but returns a pointer to a string
'  instead of a vb/pb string.
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rszGetConnectionName Alias "rszGetConnectionName" _
      ( ByVal iConnection As Long ) Export As Dword

   Dim sString As String

   sString  = rsGetConnectionName(iConnection) + Chr$(0)
   Function = StrPtr(sString)

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsGetConnectionHandle
'
'  Returns the hRas handle to the active connection based on it's "number"
'  as specified by rsActiveConnections. Returns Zero on error.
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsGetConnectionHandle Alias "rsGetConnectionHandle" _
      ( ByVal iConnection As Long ) Export As Long

   Dim iNumConn As Long
   Dim rConn(1 To 100) As RASCONN      'assuming never more than 100
                                       'active connections (safe for now!)

   iNumConn = collect_active(rConn())
   If (iConnection < 1) Or (iConnection > iNumConn) Then
      Function = 0
   Else
      Function = rConn(1).hRasConn
   End If

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsHangupConnection
'
'  Hangs up a connection given it's handle and doesn't return
'  until the connection is disconnected.
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsHangUpConnection Alias "rsHangUpConnection" _
      ( ByVal hRas As Long ) Export As Long

   hangup_and_wait hRas

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsValidEntry
'
'  Returns the entry number if the entry passed is an actual entry
'  otherwise it returns 0
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsValidEntry Alias "rsValidEntry" _
      ( zEntry As Asciiz ) Export As Long

   Dim i As Long
   Dim iNumEnt As Long
   Dim iFound As Long

   iNumEnt = rsAvailableEntries()
   If iNumEnt < 1 Then
      Function = 0
   Else
      iFound = 0
      For i = 1 To iNumEnt
         If Trim$(UCase$(rsGetEntryName(i))) = Trim$(UCase$(zEntry)) Then
            iFound = i
            Exit For
         End If
      Next i
      Function = iFound
   End If

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  experimental code
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#if 0
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  rsDialEntryWithDialog
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function rsDialEntryWithDialog Alias "rsDialEntryWithDialog" _
      ( ByVal hParent as Long, zEntry as Asciiz ) Export As Long


   Dim iRet As Long
   Dim rInfo as RASDIALDLG_TYPE

   '- Setup the instructions structure
   rInfo.dwSize = len(rInfo)
   rInfo.hwndOwner = hParent
   rInfo.dwFlags = 0
   rInfo.xDlg = 0
   rInfo.yDlg = 0
   rInfo.dwSubEntry = 0
   rInfo.dwError = 0
   rInfo.reserved1 = 0
   rInfo.reserved2 = 0

   iRet = RasDialDlg ( ByVal 0, zEntry, ByVal 0, rInfo )
   if iRet = %False then
      Function = %False
      MsgBox "Ras Dial Failed. dwError= " + Format$(rInfo.dwError)
   else
      if rInfo.dwError = 0 then
         Function = %True
      else
         Function = %False
      end if
   end if


End Function
#endif

#endif